package Servlet;

import Datos.EquipoDB;
import Datos.JornadaDB;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import Modelo.CodClub;
import Modelo.Jornada;
import Modelo.Partido;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.UUID;

public class CrearJornadaServlet extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String encoding = request.getCharacterEncoding();
        if (encoding==null) {
            request.setCharacterEncoding("UTF-8");
        }
        
        CodClub club = (CodClub) request.getSession().getAttribute("club");
        int equipos = EquipoDB.getCountEquiposClub(club);
        String operacion = request.getParameter("operacion");
        String id_jornada;
        String fecha = "";
        Date fecha_jornada = null;
        if(operacion.equals("REG")){
            id_jornada = UUID.randomUUID().toString();
        }else{
            fecha = request.getParameter("fecha_jornada");
            SimpleDateFormat formato = new SimpleDateFormat("yyyy-MM-dd");
            try{
                fecha_jornada = formato.parse(fecha);
            }catch(ParseException ex){
                  ex.printStackTrace();
            }
            String id_club = club.getId_club();
            id_jornada = JornadaDB.getJornada(fecha_jornada, id_club).getId_jornada();
            Jornada jornada= JornadaDB.getJornada(id_jornada);
            ArrayList<Partido> partidos = JornadaDB.getPartidosJornada(jornada, club);
            request.setAttribute("partidos", partidos);
        }
        
        String url = ""; 
        
        if(equipos == 0){
            url = "/mensaje.jsp?mensaje=No hay equipos para los que crear jornada";
        }else{
            url = "/crearJornada.jsp?equipos="+equipos+"&operacion="+operacion+"&id_jornada="+id_jornada+"&fecha_jornada="+fecha;
        }
        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url);
        dispatcher.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
